////////////////////////////////////////////////////////////////
// 目覚し時計ガジェット
//   Copyright (C) 2008 - 2012 AAOh inc.
////////////////////////////////////////////////////////////////

/**
 * @fileOverview 目覚し時計ガジェット
 * @author       $Author: fujishiro $
 */

(function () {
/**
 * aclock。
 *
 * @namespace
 */
aclock = {
}
})();

(function () {
/**
 * Control。
 *
 * @constructor
 */
aclock.Control = aaoh.kaze.Gadget.extend(
	aaoh.sora.ControlEx, function() {
	// Application名。
	this.APP_NAME    = 'aclock';
	this.APP_VERSION = '2.6.0';

	// Windowサイズ。
	this.WINDOW_ONDOCK_WIDTH         = 130 +  0;
	this.WINDOW_ONDOCK_HEIGHT        = 130 + 12;
	this.WINDOW_UNDOCK_WIDTH         = this.WINDOW_ONDOCK_WIDTH;
	this.WINDOW_UNDOCK_HEIGHT        = this.WINDOW_ONDOCK_HEIGHT;
	this.WINDOW_ONDOCK_MOBILE_WIDTH  = this.WINDOW_ONDOCK_WIDTH;
	this.WINDOW_ONDOCK_MOBILE_HEIGHT = this.WINDOW_ONDOCK_HEIGHT;
	this.WINDOW_UNDOCK_MOBILE_WIDTH  = this.WINDOW_ONDOCK_MOBILE_WIDTH;
	this.WINDOW_UNDOCK_MOBILE_HEIGHT = this.WINDOW_ONDOCK_MOBILE_HEIGHT;
	this.WINDOW_OPTION_WIDTH         = 250 +  0;
	this.WINDOW_OPTION_HEIGHT        = 260 + 12;
	this.WINDOW_OPTION_MOBILE_WIDTH  = 230 +  0;
	this.WINDOW_OPTION_MOBILE_HEIGHT = 180 + 12;

	// アラームモード
	this.MODE_ALARM_ON    = '1'; // アラームOn
	this.MODE_ALARM_OFF   = '0'; // アラームOff
	this.MODE_ALARM_START = '2'; // アラーム開始
	this.MODE_SNOOZE_ON   = '3'; // スヌーズOn
	this.MODE_SNOOZE_OFF  = '4'; // スヌーズOff

	// デフォルト値
	this.DEFAULT_ALERT_MSG       = this.locale.getString('ALERT_MSG');
	this.DEFAULT_SOUND_FILE      = 'alert.mp3';
	if (aaoh.kaze.Type.isSidebar()) {
		this.DEFAULT_SOUND_FILE    = 'alert.wav';

	} else if (aaoh.kaze.Type.isYahoo()) {
		this.DEFAULT_SOUND_FILE    = 'Resources/alert.mp3';
	}
	this.DEFAULT_REPEAT_INTERVAL = 3000; // msec

	// sound
	this.sound = new aaoh.kaze.Sound();

	// copyright
	this.LST_IMG_NM.push('imgCopilot');
	this.LST_LNK_NM.push('lnkCopilot');
	this.LST_URL['imgCopilot'] = 'http://copilot.jp/';
	this.LST_URL['lnkCopilot'] = 'http://copilot.jp/';
})
})();

(function () {
/**
 * Model。
 *
 * @constructor
 */
aclock.Model = aaoh.kaze.Gadget.extend(
	aaoh.sora.ModelEx, function() {
	this.data.alarm       = '12:00:00';
	this.data.alarmMode   = '0';
	this.data.type        = '1';
	this.data.isDispSec   = true;
	this.data.isSnooze    = true;
	this.data.isAlert     = true;
	this.data.isAlertDef  = true;
	this.data.alertMsg    = '';
	this.data.isSound     = true;
	this.data.isSoundDef  = true;
	this.data.soundFile   = '';
	this.data.numSoundVol = 50;
});
	/**
	 * 設定情報の読込み(iGoogle)。
	 */
	aclock.Model.prototype.
	readDataForIGoogle = function() {
		var alarm       = aaoh.sora.App.control.storage.readString('alarm');
		var alarmMode   = aaoh.sora.App.control.storage.readString('alarmMode');
		var type        = aaoh.sora.App.control.storage.readString('type');
		var isDispSec   = aaoh.sora.App.control.storage.readString('isDispSec');
		var isSnooze    = aaoh.sora.App.control.storage.readString('isSnooze');
		var isAlert     = aaoh.sora.App.control.storage.readString('isAlert');
		var isAlertDef  = aaoh.sora.App.control.storage.readString('isAlertDef');
		var alertMsg    = aaoh.sora.App.control.storage.readString('alertMsg');
		var isSound     = aaoh.sora.App.control.storage.readString('isSound');
		var isSoundDef  = aaoh.sora.App.control.storage.readString('isSoundDef');
		var soundFile   = aaoh.sora.App.control.storage.readString('soundFile');
		var numSoundVol = aaoh.sora.App.control.storage.readString('numSoundVol');

		if (alarm != null) {
			this.data.alarm       = alarm;
		}
		if (alarmMode != null) {
			this.data.alarmMode   = alarmMode;
		}
		if (type != null) {
			this.data.type        = type;
		}
		this.data.isDispSec     = isDispSec;
		this.data.isSnooze      = isSnooze;
		this.data.isAlert       = isAlert;
		this.data.isAlertDef    = isAlertDef;
		if (alertMsg != null) {
			this.data.alertMsg    = alertMsg;
		}
		this.data.isSound       = isSound;
		this.data.isSoundDef    = isSoundDef;
		if (soundFile != null) {
			this.data.soundFile   = soundFile;
		}
		if (numSoundVol > 0) {
			this.data.numSoundVol = numSoundVol;
		}
	}

	/**
	 * 設定情報の書込み(iGoogle)。
	 */
	aclock.Model.prototype.
	writeDataForIGoogle = function() {
		aaoh.sora.App.control.storage.writeString(
			'alarm', this.data.alarm
		);
		aaoh.sora.App.control.storage.writeString(
			'alarmMode', this.data.alarmMode
		);
		aaoh.sora.App.control.storage.writeString(
			'type', this.data.type
		);
		aaoh.sora.App.control.storage.writeString(
			'isDispSec', this.data.isDispSec
		);
		aaoh.sora.App.control.storage.writeString(
			'isSnooze', this.data.isSnooze
		);
		aaoh.sora.App.control.storage.writeString(
			'isAlert', this.data.isAlert
		);
		aaoh.sora.App.control.storage.writeString(
			'isAlertDef', this.data.isAlertDef
		);
		aaoh.sora.App.control.storage.writeString(
			'alertMsg', this.data.alertMsg
		);
		aaoh.sora.App.control.storage.writeString(
			'isSound', this.data.isSound
		);
		aaoh.sora.App.control.storage.writeString(
			'isSoundDef', this.data.isSoundDef
		);
		aaoh.sora.App.control.storage.writeString(
			'soundFile', this.data.soundFile
		);
		aaoh.sora.App.control.storage.writeString(
			'numSoundVol', this.data.numSoundVol
		);
	}
})();

(function () {
/**
 * App。
 *
 * @namespace
 */
aaoh.sora.App = {
	control: new aclock.Control(),
	model:   new aclock.Model(),
	main:    null,
	option:  null,

	/**
	 * 初期化。
	 *
	 * @param {String} target 初期化するターゲット
	 */
	init: function(target) {
		if (
			target != null && target == aaoh.sora.App.control.MAIN_NM
		) {
			aaoh.sora.App.main   = new aclock.Main();
			aaoh.sora.App.option = null;

		} else if (
			target != null && target == aaoh.sora.App.control.OPTION_NM
		) {
			aaoh.sora.App.main   = null;
			aaoh.sora.App.option = new aclock.Option();

		} else {
			aaoh.sora.App.main   = new aclock.Main();
			aaoh.sora.App.option = new aclock.Option();
		}

		// バージョンチェックを行う
		aaoh.sora.App.control.FLG_UPDATE = true;

		aaoh.sora.App.control.init();
	}
}
})();
